diff --git a/lustre/include/lustre_dlm.h b/lustre/include/lustre_dlm.h
index 27feb6f..8c5553a 100644
--- a/lustre/include/lustre_dlm.h
+++ b/lustre/include/lustre_dlm.h
@@ -846,26 +1113,33 @@ typedef int (*ldlm_processing_policy)(struct ldlm_lock *lock, int *flags,
                                       int first_enq, ldlm_error_t *err,
                                       cfs_list_t *work_list);
 
-/*
- * Iterators.
+/**
+ * Return values for lock iterators.
+ * Also used during deciding of lock
+ * granting and cancelling.
  */
-
 #define LDLM_ITER_CONTINUE 1 /* keep iterating */
 #define LDLM_ITER_STOP     2 /* stop iterating */
 
 typedef int (*ldlm_iterator_t)(struct ldlm_lock *, void *);
 typedef int (*ldlm_res_iterator_t)(struct ldlm_resource *, void *);
 
+/** \defgroup ldlm_iterator Lock iterators
+ *
+ * LDLM provides for a way to iterate through every lock on a resource or
+ * namespace. Every resource on namespace.
+ * @{ */
 int ldlm_resource_foreach(struct ldlm_resource *res, ldlm_iterator_t iter,
                           void *closure);
 int ldlm_namespace_foreach(struct ldlm_namespace *ns, ldlm_iterator_t iter,
                            void *closure);
 int ldlm_namespace_foreach_res(struct ldlm_namespace *ns,
                                ldlm_res_iterator_t iter, void *closure);
-
-int ldlm_replay_locks(struct obd_import *imp);
 int ldlm_resource_iterate(struct ldlm_namespace *, const struct ldlm_res_id *,
                            ldlm_iterator_t iter, void *data);
+/** @} ldlm_iterator */
+
+int ldlm_replay_locks(struct obd_import *imp);
 
 /* ldlm_flock.c */
 int ldlm_flock_completion_ast(struct ldlm_lock *lock, int flags, void *data);
@@ -875,16 +1149,42 @@ __u64 ldlm_extent_shift_kms(struct ldlm_lock *lock, __u64 old_kms);
 
 
 /* ldlm_lockd.c */
+/** \defgroup ldlm_srv_ast Server AST handlers
+ * These are AST handlers used by server code.
+ * Their property is that they are just preparing RPCs to be sent to clients.
+ * @{
+ */
 int ldlm_server_blocking_ast(struct ldlm_lock *, struct ldlm_lock_desc *,
                              void *data, int flag);
 int ldlm_server_completion_ast(struct ldlm_lock *lock, int flags, void *data);
 int ldlm_server_glimpse_ast(struct ldlm_lock *lock, void *data);
+/** @} ldlm_srv_ast */
+
+struct ldlm_callback_suite {
+        ldlm_completion_callback lcs_completion;
+        ldlm_blocking_callback   lcs_blocking;
+        ldlm_glimpse_callback    lcs_glimpse;
+        ldlm_weigh_callback      lcs_weigh;
+};
+
+/** \defgroup ldlm_handlers Server ldlm handlers
+ * These are handler functions that should be called by "frontends" such as
+ * MDT or OST to pass through ldlm requests to LDLM for handling
+ * @{
+ */
 int ldlm_handle_enqueue(struct ptlrpc_request *req, ldlm_completion_callback,
                         ldlm_blocking_callback, ldlm_glimpse_callback);
+int ldlm_handle_enqueue0(struct ldlm_namespace *ns, struct ptlrpc_request *req,
+                         const struct ldlm_request *dlm_req,
+                         const struct ldlm_callback_suite *cbs);
 int ldlm_handle_convert(struct ptlrpc_request *req);
+int ldlm_handle_convert0(struct ptlrpc_request *req,
+                         const struct ldlm_request *dlm_req);
 int ldlm_handle_cancel(struct ptlrpc_request *req);
 int ldlm_request_cancel(struct ptlrpc_request *req,
                         const struct ldlm_request *dlm_req, int first);
+/** @} ldlm_handlers */
+
 int ldlm_del_waiting_lock(struct ldlm_lock *lock);
 int ldlm_refresh_waiting_lock(struct ldlm_lock *lock, int timeout);
 void ldlm_revoke_export_locks(struct obd_export *exp);
@@ -902,6 +1202,9 @@ struct ldlm_lock *__ldlm_handle2lock(const struct lustre_handle *, int flags);
 void ldlm_cancel_callback(struct ldlm_lock *);
 int ldlm_lock_remove_from_lru(struct ldlm_lock *);
 
+/**
+ * Obtain a lock reference by its handle.
+ */
 static inline struct ldlm_lock *ldlm_handle2lock(const struct lustre_handle *h)
 {
         return __ldlm_handle2lock(h, 0);
@@ -921,6 +1224,9 @@ ldlm_handle2lock_long(const struct lustre_handle *h, int flags)
         return lock;
 }
 
+/**
+ * Update LVBO on a resource taking into account data from reqest \param r
+ */
 static inline int ldlm_res_lvbo_update(struct ldlm_resource *res,
                                        struct ptlrpc_request *r, int increase)
 {
@@ -1052,21 +1358,25 @@ int ldlm_lock_change_resource(struct ldlm_namespace *, struct ldlm_lock *,
         lu_ref_del(&(res)->lr_reference, __FUNCTION__, cfs_current());  \
 } while (0)
 
-struct ldlm_callback_suite {
-        ldlm_completion_callback lcs_completion;
-        ldlm_blocking_callback   lcs_blocking;
-        ldlm_glimpse_callback    lcs_glimpse;
-        ldlm_weigh_callback      lcs_weigh;
-};
-
 /* ldlm_request.c */
 int ldlm_expired_completion_wait(void *data);
+/** \defgroup ldlm_local_ast Default AST handlers for local locks
+ * These AST handlers are typically used for server-side local locks and are
+ * also used byclient-side lock handlers to perform minimum level base
+ * processing
+ * @{ */
 int ldlm_blocking_ast_nocheck(struct ldlm_lock *lock);
 int ldlm_blocking_ast(struct ldlm_lock *lock, struct ldlm_lock_desc *desc,
                       void *data, int flag);
 int ldlm_glimpse_ast(struct ldlm_lock *lock, void *reqp);
 int ldlm_completion_ast_async(struct ldlm_lock *lock, int flags, void *data);
 int ldlm_completion_ast(struct ldlm_lock *lock, int flags, void *data);
+/** @} ldlm_local_ast */
+
+/** \defgroup ldlm_cli_api API to operate on locks from actual ldlm users.
+ * These are typically used by client and server (*_local versions)
+ * to obtain and release locks
+ * @{ */
 int ldlm_cli_enqueue(struct obd_export *exp, struct ptlrpc_request **reqp,
                      struct ldlm_enqueue_info *einfo,
                      const struct ldlm_res_id *res_id,
@@ -1081,9 +1391,6 @@ int ldlm_prep_elc_req(struct obd_export *exp,
                       struct ptlrpc_request *req,
                       int version, int opc, int canceloff,
                       cfs_list_t *cancels, int count);
-int ldlm_handle_enqueue0(struct ldlm_namespace *ns, struct ptlrpc_request *req,
-                         const struct ldlm_request *dlm_req,
-                         const struct ldlm_callback_suite *cbs);
 int ldlm_cli_enqueue_fini(struct obd_export *exp, struct ptlrpc_request *req,
                           ldlm_type_t type, __u8 with_policy, ldlm_mode_t mode,
                           int *flags, void *lvb, __u32 lvb_len,
@@ -1098,12 +1405,8 @@ int ldlm_cli_enqueue_local(struct ldlm_namespace *ns,
                            void *data, __u32 lvb_len,
                            const __u64 *client_cookie,
                            struct lustre_handle *lockh);
-int ldlm_server_ast(struct lustre_handle *lockh, struct ldlm_lock_desc *new,
-                    void *data, __u32 data_len);
 int ldlm_cli_convert(struct lustre_handle *, int new_mode, __u32 *flags);
 int ldlm_cli_update_pool(struct ptlrpc_request *req);
-int ldlm_handle_convert0(struct ptlrpc_request *req,
-                         const struct ldlm_request *dlm_req);
 int ldlm_cli_cancel(struct lustre_handle *lockh);
 int ldlm_cli_cancel_unused(struct ldlm_namespace *, const struct ldlm_res_id *,
                            ldlm_cancel_flags_t flags, void *opaque);
@@ -1122,6 +1425,7 @@ int ldlm_cancel_resource_local(struct ldlm_resource *res,
                                ldlm_cancel_flags_t cancel_flags, void *opaque);
 int ldlm_cli_cancel_list(cfs_list_t *head, int count,
                          struct ptlrpc_request *req, ldlm_cancel_flags_t flags);
+/** @} ldlm_cli_api */
 
 /* mds/handler.c */
 /* This has to be here because recursive inclusion sucks. */
@@ -1148,23 +1452,26 @@ enum lock_res_type {
         LRT_NEW
 };
 
+/** Lock resource */
 static inline void lock_res(struct ldlm_resource *res)
 {
         cfs_spin_lock(&res->lr_lock);
 }
 
+/** Lock resource with a way to instruct lockdep code about nestedness-safe */
 static inline void lock_res_nested(struct ldlm_resource *res,
                                    enum lock_res_type mode)
 {
         cfs_spin_lock_nested(&res->lr_lock, mode);
 }
 
-
+/** Unlock resource */
 static inline void unlock_res(struct ldlm_resource *res)
 {
         cfs_spin_unlock(&res->lr_lock);
 }
 
+/** Check if resource is already locked, assert if not */
 static inline void check_res_locked(struct ldlm_resource *res)
 {
         LASSERT_SPIN_LOCKED(&res->lr_lock);
@@ -1174,6 +1481,10 @@ struct ldlm_resource * lock_res_and_lock(struct ldlm_lock *lock);
 void unlock_res_and_lock(struct ldlm_lock *lock);
 
 /* ldlm_pool.c */
+/** \defgroup ldlm_pools
+ * Various ldlm pool related functions. There are not used outside of ldlm
+ * @{
+ */
 void ldlm_pools_recalc(ldlm_side_t client);
 int ldlm_pools_init(void);
 void ldlm_pools_fini(void);
@@ -1194,7 +1505,7 @@ void ldlm_pool_set_clv(struct ldlm_pool *pl, __u64 clv);
 void ldlm_pool_set_limit(struct ldlm_pool *pl, __u32 limit);
 void ldlm_pool_add(struct ldlm_pool *pl, struct ldlm_lock *lock);
 void ldlm_pool_del(struct ldlm_pool *pl, struct ldlm_lock *lock);
-
-/** @} ldlm */
+/** @} */
 
 #endif
+/** @} LDLM */
diff --git a/lustre/ldlm/l_lock.c b/lustre/ldlm/l_lock.c
index 88a56fa..3918ba9 100644
--- a/lustre/ldlm/l_lock.c
+++ b/lustre/ldlm/l_lock.c
@@ -44,7 +44,9 @@
 #include <lustre_dlm.h>
 #include <lustre_lib.h>
 
-/*
+/**
+ * Lock a lock and its resource.
+ *
  * ldlm locking uses resource to serialize access to locks
  * but there is a case when we change resource of lock upon
  * enqueue reply. we rely on that lock->l_resource = new_res
@@ -65,6 +67,9 @@ struct ldlm_resource * lock_res_and_lock(struct ldlm_lock *lock)
         return res;
 }
 
+/**
+ * Unlock a lock and its resource previously locked with lock_res_and_lock
+ */
 void unlock_res_and_lock(struct ldlm_lock *lock)
 {
         struct ldlm_resource *res = lock->l_resource;
diff --git a/lustre/ldlm/ldlm_extent.c b/lustre/ldlm/ldlm_extent.c
index 780296d..b9252bb 100644
--- a/lustre/ldlm/ldlm_extent.c
+++ b/lustre/ldlm/ldlm_extent.c
@@ -39,6 +39,16 @@
  * Author: Phil Schwan <phil@clusterfs.com>
  */
 
+/**
+ * This file contains implementation of EXTENT lock type
+ *
+ * EXTENT lock type has a definition of "Extent" represented by
+ * starting and ending offsets (inclusive).
+ * There are several extent lock modes, some of them could be mutually
+ * incompatible. Extent locks are considered incompatible if their modes
+ * are incompatible and their extents intersect.
+ */
+
 #define DEBUG_SUBSYSTEM S_LDLM
 #ifndef __KERNEL__
 # include <liblustre.h>
@@ -56,7 +66,13 @@
 
 #define LDLM_MAX_GROWN_EXTENT (32 * 1024 * 1024 - 1)
 
-/* fixup the ldlm_extent after expanding */
+/**
+ * Fixup the ldlm_extent after expanding.
+ *
+ * After expansion have been done, we might still want to do certain adjusting
+ * based on overal contendedness of the resource and the like to avoid granting
+ * overly wide locks.
+ */
 static void ldlm_extent_internal_policy_fixup(struct ldlm_lock *req,
                                               struct ldlm_extent *new_ex,
                                               int conflicting)
@@ -100,7 +116,8 @@ static void ldlm_extent_internal_policy_fixup(struct ldlm_lock *req,
                  mask, new_ex->end, req_end);
 }
 
-/* The purpose of this function is to return:
+/**
+ * The purpose of this function is to return:
  * - the maximum extent
  * - containing the requested extent
  * - and not overlapping existing conflicting extents outside the requested one
@@ -340,14 +357,17 @@ static enum interval_iter ldlm_extent_compat_cb(struct interval_node *n,
         RETURN(INTERVAL_ITER_CONT);
 }
 
-/* Determine if the lock is compatible with all locks on the queue.
- * We stop walking the queue if we hit ourselves so we don't take
- * conflicting locks enqueued after us into accound, or we'd wait forever.
+/**
+ * Determine if the lock is compatible with all locks on the queue.
+ * 
+ * If \param work_list is provided, conflicting locks are linked there.
+ * If \param work_list is not provided, we exit this function on first conflict.
  *
- * 0 if the lock is not compatible
- * 1 if the lock is compatible
- * 2 if this group lock is compatible and requires no further checking
- * negative error, such as EWOULDBLOCK for group locks
+ * \retval 0 if the lock is not compatible
+ * \retval 1 if the lock is compatible
+ * \retval 2 if \param req is a group lock and it is compatible and requires
+ *           no further checking
+ * \retval negative error, such as EWOULDBLOCK for group locks
  */
 static int
 ldlm_extent_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
@@ -436,6 +456,11 @@ ldlm_extent_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
                         lock = cfs_list_entry(tmp, struct ldlm_lock,
                                               l_res_link);
 
+                        /**
+                         * We stop walking the queue if we hit ourselves so
+                         * we don't take conflicting locks enqueued after us
+                         * into account, or we'd wait forever.
+                         */
                         if (req == lock)
                                 break;
 
@@ -611,6 +636,12 @@ destroylock:
         RETURN(compat);
 }
 
+/**
+ * Discard all AST work items from list
+ *
+ * If for whatever reason we do not want to send ASTs to conflicting locks
+ * anymore, disassemble the list with this function
+ */
 static void discard_bl_list(cfs_list_t *bl_list)
 {
         cfs_list_t *tmp, *pos;
@@ -632,13 +663,21 @@ static void discard_bl_list(cfs_list_t *bl_list)
         EXIT;
 }
 
-/* If first_enq is 0 (ie, called from ldlm_reprocess_queue):
-  *   - blocking ASTs have already been sent
-  *   - must call this function with the ns lock held
-  *
-  * If first_enq is 1 (ie, called from ldlm_lock_enqueue):
-  *   - blocking ASTs have not been sent
-  *   - must call this function with the ns lock held once */
+/**
+ * Process a granting attempt for extent lock.
+ * Must be called under ns lock held.
+ *
+ * This function tries to see if there are any conflicts for \param lock in
+ * any of the granted or waiting queues. If no conflict met in both,
+ * the lock is granted.
+ *
+ * If \param first_enq is 0 (ie, called from ldlm_reprocess_queue):
+ *   - blocking ASTs have already been sent
+ *
+ * If \param first_enq is 1 (ie, called from ldlm_lock_enqueue):
+ *   - blocking ASTs have not been sent yet, so list of conflicting locks
+ *     would be collected and ASTs sent.
+ */
 int ldlm_process_extent_lock(struct ldlm_lock *lock, int *flags, int first_enq,
                              ldlm_error_t *err, cfs_list_t *work_list)
 {
@@ -716,7 +755,6 @@ int ldlm_process_extent_lock(struct ldlm_lock *lock, int *flags, int first_enq,
  
                 lock_res(res);
                 if (rc == -ERESTART) {
-
                         /* 15715: The lock was granted and destroyed after
                          * resource lock was dropped. Interval node was freed
                          * in ldlm_lock_destroy. Anyway, this always happens
@@ -856,6 +894,9 @@ static inline int lock_mode_to_index(ldlm_mode_t mode)
         return index;
 }
 
+/**
+ * Add newly granted lock into interval tree for the resource
+ */
 void ldlm_extent_add_lock(struct ldlm_resource *res,
                           struct ldlm_lock *lock)
 {
@@ -893,6 +934,9 @@ void ldlm_extent_add_lock(struct ldlm_resource *res,
         ldlm_resource_add_lock(res, &res->lr_granted, lock);
 }
 
+/**
+ * Remove cancelled lock from reource interval tree
+ */
 void ldlm_extent_unlink_lock(struct ldlm_lock *lock)
 {
         struct ldlm_resource *res = lock->l_resource;
diff --git a/lustre/ldlm/ldlm_flock.c b/lustre/ldlm/ldlm_flock.c
index 8e17167..fcf5155 100644
--- a/lustre/ldlm/ldlm_flock.c
+++ b/lustre/ldlm/ldlm_flock.c
@@ -38,6 +38,28 @@
  * Lustre is a trademark of Sun Microsystems, Inc.
  */
 
+/**
+ * This file implements POSIX lock type for lustre.
+ * it's policy properties are start and end of extent and pid.
+ *
+ * These locks are only done through MDS due to POSIX semantics requiring
+ * e.g. that locks could be only partially released and as such split into
+ * two parts and also two adjacent locks from the same process to be merged
+ * into a single wider lock.
+ *
+ * lock modes are mapped like this:
+ * PR and PW for READ and WRITE locks
+ * NL to request a releasing of a portion of the lock
+ *
+ * these flock locks never timeout.
+ *
+ * This code also has limited support for flock locks (whole file locks from
+ * flock() system call, also called bsd locks). Limitaion is only process
+ * that requested a lcok can release it, so if you share a file descriptor
+ * with another process with this lock held and attempt to release such a lock
+ * from that other process, it won't do anything.
+ */
+
 #define DEBUG_SUBSYSTEM S_LDLM
 
 #ifdef __KERNEL__
@@ -122,6 +144,18 @@ ldlm_flock_destroy(struct ldlm_lock *lock, ldlm_mode_t mode, int flags)
         EXIT;
 }
 
+/**
+ * POSIX locks deadlock detection code.
+ *
+ * Given a new lock \param req and an existing lock it conflicts with
+ * \param blocking_lock, we need to iterate through all blocked posix locks
+ * for this export and see if there is a deadlock condition arising.
+ * (i.e. when one client holds a lock on something and want a lock on something
+ * else and at the same time another client has the opposite situation).
+ *
+ * This function has a horrible double O(n^2) list iterations that really
+ * suck a lot of CPU time on a highly-contended resources.
+ */
 static int
 ldlm_flock_deadlock(struct ldlm_lock *req, struct ldlm_lock *blocking_lock)
 {
@@ -153,6 +187,24 @@ restart:
         return 0;
 }
 
+/**
+ * Process a granting attempt for flock lock.
+ * Must be called under ns lock held.
+ *
+ * This function tries to see if there are any conflicts for \param req in
+ * any of the granted or waiting queues. If no conflict met in both,
+ * the lock is granted.
+ *
+ * It is also responsible for splitting a lock if a portion of the lock
+ * is released.
+ *
+ * If \param first_enq is 0 (ie, called from ldlm_reprocess_queue):
+ *   - blocking ASTs have already been sent
+ *
+ * If \param first_enq is 1 (ie, called from ldlm_lock_enqueue):
+ *   - blocking ASTs have not been sent yet, so list of conflicting locks
+ *     would be collected and ASTs sent.
+ */
 int
 ldlm_process_flock_lock(struct ldlm_lock *req, int *flags, int first_enq,
                         ldlm_error_t *err, cfs_list_t *work_list)
@@ -466,9 +518,9 @@ restart:
         }
 
         /* In case we're reprocessing the requested lock we can't destroy
-         * it until after calling ldlm_ast_work_item() above so that lawi()
-         * can bump the reference count on req. Otherwise req could be freed
-         * before the completion AST can be sent.  */
+         * it until after calling ldlm_add_ast_work_item() above so that laawi()
+         * can bump the reference count on \param req. Otherwise \param req
+         * could be freed before the completion AST can be sent.  */
         if (added)
                 ldlm_flock_destroy(req, mode, *flags);
 
@@ -501,7 +553,7 @@ ldlm_flock_interrupted_wait(void *data)
 }
 
 /**
- * Flock completion calback function.
+ * Flock completion callback function.
  *
  * \param lock [in,out]: A lock to be handled
  * \param flags    [in]: flags
diff --git a/lustre/ldlm/ldlm_inodebits.c b/lustre/ldlm/ldlm_inodebits.c
index 406d059..c9296c3 100644
--- a/lustre/ldlm/ldlm_inodebits.c
+++ b/lustre/ldlm/ldlm_inodebits.c
@@ -39,6 +39,16 @@
  * Author: Phil Schwan <phil@clusterfs.com>
  */
 
+/**
+ * This file contains implementation for IBITS lock type
+ *
+ * IBITS lock type contains a bit mask determining various properties of an
+ * object. Meaning to specific bits are specific to the caller and opaque to
+ * LDLM code.
+ * Locks with non-intersecting bitmasks are considered not conflicting.
+ *
+ */
+
 #define DEBUG_SUBSYSTEM S_LDLM
 #ifndef __KERNEL__
 # include <liblustre.h>
@@ -50,7 +60,22 @@
 
 #include "ldlm_internal.h"
 
-/* Determine if the lock is compatible with all locks on the queue. */
+/**
+ * Determine if the lock is compatible with all locks on the queue.
+ *
+ * If \param work_list is provided, conflicting locks are linked there.
+ * If \param work_list is not provided, we exit this function on first conflict.
+ *
+ * \retval 0 if there are conflicting locks in the \param queue
+ * \retval 1 if the lock is compatible to all locks in \param queue
+ *
+ * IBITS locks in granted queue are organized in bunches of same-mode/same-bits
+ * locks called "skip lists". First lock in the bunch contains a pointer to
+ * the end of the bunch.
+ * This allows us to skip entire bunch when iterating the list in search for
+ * conflicting locks if first lock of the bunch is not conflicting with us.
+ *
+ */
 static int
 ldlm_inodebits_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
                             cfs_list_t *work_list)
@@ -71,6 +96,11 @@ ldlm_inodebits_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
 
                 lock = cfs_list_entry(tmp, struct ldlm_lock, l_res_link);
 
+                /**
+                 * We stop walking the queue if we hit ourselves so we don't
+                 * take conflicting locks enqueued after us into account,
+                 * or we'd wait forever.
+                 */
                 if (req == lock)
                         RETURN(compat);
 
@@ -97,8 +127,11 @@ ldlm_inodebits_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
 
                         /* locks with bits overlapped are conflicting locks */
                         if (lock->l_policy_data.l_inodebits.bits & req_bits) {
-                                /* COS lock from the same client is
-                                   not conflicting */
+                                /**
+                                 * COS lock mode has a special compatibility
+                                 * requirements, it is only compatible to locks
+                                 * from the same client.
+                                 */
                                 if (lock->l_req_mode == LCK_COS &&
                                     lock->l_client_cookie == req->l_client_cookie)
                                         goto not_conflicting;
@@ -133,13 +166,22 @@ ldlm_inodebits_compat_queue(cfs_list_t *queue, struct ldlm_lock *req,
         RETURN(compat);
 }
 
-/* If first_enq is 0 (ie, called from ldlm_reprocess_queue):
-  *   - blocking ASTs have already been sent
-  *   - must call this function with the ns lock held
-  *
-  * If first_enq is 1 (ie, called from ldlm_lock_enqueue):
-  *   - blocking ASTs have not been sent
-  *   - must call this function with the ns lock held once */
+/**
+ * Process a granting attempt for ibits lock.
+ * Must be called under ns lock held
+ *
+ * This function tries to see if there are any conflicts for \param lock in
+ * any of the granted or waiting queues. If no conflict met in both,
+ * the lock is granted.
+ *
+ * If \param first_enq is 0 (ie, called from ldlm_reprocess_queue):
+ *   - blocking ASTs have already been sent
+ *
+ * If \param first_enq is 1 (ie, called from ldlm_lock_enqueue):
+ *   - blocking ASTs have not been sent yet, so list of conflicting locks
+ *     would be collected and ASTs sent.
+ *
+ */
 int ldlm_process_inodebits_lock(struct ldlm_lock *lock, int *flags,
                                 int first_enq, ldlm_error_t *err,
                                 cfs_list_t *work_list)
diff --git a/lustre/ldlm/ldlm_lib.c b/lustre/ldlm/ldlm_lib.c
index 943f0b1..e74270c 100644
--- a/lustre/ldlm/ldlm_lib.c
+++ b/lustre/ldlm/ldlm_lib.c
@@ -34,6 +34,12 @@
  * Lustre is a trademark of Sun Microsystems, Inc.
  */
 
+/**
+ * This file is actually much more related to ptlrpc code than ldlm.
+ * It primarily deals with various client/target related logic
+ * including recovery topics.
+ */
+
 #ifndef EXPORT_SYMTAB
 # define EXPORT_SYMTAB
 #endif
